
--
--	Poisoner by humfras
--	All rights reserved
--

Poisoner = LibStub("AceAddon-3.0"):NewAddon("Poisoner", "AceConsole-3.0", "AceEvent-3.0")


local function debug(...)
	if Poisoner.debug then
		print(...)
	end
end

--local Poisoner = CreateFrame("FRAME", "Poisoner")

local textureprefix = "Interface\\Icons\\"
local texturesuffix = ""
local playerGUID
local currentbuffs = {}
local k, v, cat, spells, spellID, _
local maxtempmodels = 0

if true then
	textureprefix = "Interface\\AddOns\\Poisoner\\images\\"
end

local fstrata = {
	[1] = "BACKGROUND",
	[2] = "LOW",
	[3] = "MEDIUM",
	[4] = "HIGH",
	[5] = "DIALOG",
	[6] = "FULLSCREEN",
	[7] = "FULLSCREEN_DIALOG",
	[8] = "TOOLTIP",
}

local spells = {
	[2823] = "Deadly Poison",
	[8679] = "Wound Poison",
	[3408] = "Crippling Poison",
	[5761] = "Mind-numbing Poison",
	[108211] = "Leeching Poison",
	[108215] = "Paralytic Poison",
}

local spellgroup = {
	[2823] = "Lethal",
	[8679] = "Lethal",
	
	[3408] = "Non-Lethal",
	[5761] = "Non-Lethal",
	[108211] = "Non-Lethal",
	[108215] = "Non-Lethal",
}

local poisons = {
	["Lethal"] = {
		[2823] = "Deadly Poison",
		[8679] = "Wound Poison",
	},
	["Non-Lethal"] = {
		[3408] = "Crippling Poison",
		[5761] = "Mind-numbing Poison",
		[108211] = "Leeching Poison",
		[108215] = "Paralytic Poison",
	},
}

local events = {
	["COMBAT_LOG_EVENT_UNFILTERED"] = true,
	["PLAYER_LOGIN"] = true,
	["PLAYER_ENTERING_WORLD"] = true,
	["SPELLS_CHANGED"] = true,
	["PLAYER_REGEN_DISABLED"] = true,
	["PLAYER_REGEN_ENABLED"] = true,
	["UNIT_AURA"] = true,
}

local CLEU_events = {
	["SPELL_AURA_APPLIED"] = true,
	["SPELL_AURA_REFRESH"] = true,
	["SPELL_AURA_REMOVED"] = true,
	["SPELL_CAST_SUCCESS"] = true,
	["SPELL_INTERRUPT"] = true,
	["SPELL_MISSED"] = true,
	["SPELL_UPDATE_COOLDOWN"] = true,
}

local function GetSquarePoint(angle, lengthX, lengthY)
	if not lengthY and lengthX then lengthY = lengthX end
	local angle = tonumber(angle)
	local lengthX = tonumber(lengthX)
	local lengthY = tonumber(lengthY)
	
	while angle > 360 do
		angle = angle - 360
	end
	
	local x, y, per = 0, 0, 0
	local modx, mody = 1, 1
	
	if angle == 270 then
		x = -lengthX/2
		y = lengthY/2
	elseif angle == 180 then
		x = lengthX/2
		y = lengthY/2
	elseif angle == 90 then
		x = lengthX/2
		y = -lengthY/2
	elseif angle == 0 or angle == 360 then
		x = -lengthX/2
		y = -lengthY/2
	elseif angle > 270 then
		angle = angle - 270
		per = 100/90*angle
		if per == 50 then
			x = -lengthX/2
			y = 0
		else
			x = -lengthX/2
			y = 0 + lengthY/2 - lengthY*per/100
		end
	elseif angle > 180 then
		angle = angle - 180
		per = 100/90*angle
		if per == 50 then
			x = 0
			y = lengthY/2
		else
			x = 0 + lengthX/2 - lengthX*per/100
			y = lengthY/2
		end
	elseif angle > 90 then
		angle = angle - 90
		per = 100/90*angle
		if per == 50 then
			x = lengthX/2
			y = 0
		else
			x = lengthX/2
			y = 0 - lengthY/2 + lengthY*per/100
		end
	else
		per = 100/90*angle
		if per == 50 then
			x = 0
			y = -lengthY/2
		else
			x = 0 - lengthX/2 + lengthX*per/100
			y = -lengthY/2
		end
	end
	
	return x, y
	
end

local function GetCircularPoint(angle, radius)
	
	local angle = tonumber(angle)
	local radius = tonumber(radius)
	
	while angle > 360 do
		angle = angle - 360
	end
	
	local x, y
	
	if angle == 270 then
		x = -radius
		y = 0
	elseif angle == 180 then
		x = 0
		y = -radius
	elseif angle == 90 then
		x = radius
		y = 0
	elseif angle == 0 or angle == 360 then
		x = 0
		y = radius
	elseif angle > 270 then
		x = -(radius * cos(angle-270))
		y = radius * sin(angle-270)
	elseif angle > 180 then
		x = -(radius * sin(angle-180))
		y = -(radius * cos(angle-180))
	elseif angle > 90 then
		x = radius * cos(angle-90)
		y = -(radius * sin(angle-90))
	else
		x = radius * sin(angle)
		y = radius * cos(angle)
	end
	
	return x,y
	
end

local function get8coords(l,r,t,b,rota)
	
	rota = tonumber(rota)
	
	if rota == 90 then
		return l, b, r, b, l, t, r, t
	elseif rota == 180 then
		return r, b, r, t, l, b, l, t
	elseif rota == 270 then
		return r, t, l, t, r, b, l, b
	else
		return l, t, l, b, r, t, r, b
	end
	
end

local function createmainconfig(ot)
	if not ot then return end
	
	local t = {}

	t.enable = {
		name = "Enable",
		desc = "Enables / disables the castbar",
		order = 0,
		type = "toggle",
		set = function(info,val)
			self.db.profile[info[1]].enabled = val
		end,
		get = function(info) return self.db.profile[info[1]].enabled end
	}
	
	t.description = {
		name = "",
		order = 0.1,
		type = "description"
	}
	t.scale = {
		name = "Scale",
		desc = "frame scale",
		order = 0.2,
		type = "range",
		min = 0.1,
		max = 2,
		step = 0.1,
		set = function(info, val)
			self.db.profile[info[1]].scale = val
			end,
		get = function(info) return self.db.profile[info[1]].scale end
	}
	t.alpha = {
		name = "Alpha",
		desc = "frame alpha",
		order = 0.3,
		type = "range",
		min = 0,
		max = 1,
		step = 0.05,
		set = function(info, val)
			self.db.profile[info[1]].alpha = val
		end,
		get = function(info) return self.db.profile[info[1]].alpha end
	}
	t.framelevel = {
		name = "Level",
		desc = "FrameLevel",
		order = 1,
		type = "range",
		min = 1,
		max = 20,
		step = 1,
		set = function(info, val)
			self.db.profile[info[1]].framelevel = val
		end,
		get = function(info) return self.db.profile[info[1]].level end
	}
	t.framestrata = {
		name = "Frame Strata",
		desc = "Controls the frame strata of the frame.",
		type = "select",
		order = 5,
		values = fstrata,
		set = function(info, value)
			self.db.profile[info[1]].framestrata = value
		end,
		get = function(info, value)
			return self.db.profile[info[1]].framestrata
		end,
	}
	t.positionsetting = {
		name = "Position settings",
		order = 10,
		type = "header",
		width = "full",
	}
	t.posx = {
		name = "X Offset",
		desc = "horizontal position",
		order = 10.3,
		type = "range",
	--	disabled = function() if self.db.profile[info[1]].anchor == "Static" or self.db.profile[info[1]].anchor == "Cursor" then return false else return true end end,
		min = -200,
		max = 200,
		step = 1,
		set = function(info, val) 
			self.db.profile[info[1]].point.ofsx = val
		end,
		get = function(info) return self.db.profile[info[1]].point.ofsx end
	}
	t.posy = {
		name = "Y Offset",
		desc = "vertical position",
		order = 10.4,
		type = "range",
	--	disabled = function() if self.db.profile[info[1]].anchor == "Static" or self.db.profile[info[1]].anchor == "Cursor" then return false else return true end end,
		min = -200,
		max = 200,
		step = 1,
		set = function(info, val) 
			self.db.profile[info[1]].point.ofsy = val
		end,
		get = function(info) return self.db.profile[info[1]].point.ofsy end
	}
	
	if ot.Castbar then
		t.Castbar = {
			name = "Castbar",
			order = 1,
			type = "group",
			args = {
				enable = {
					name = "Enable",
					desc = "Enables / disables the castbar",
					order = 0,
					type = "toggle",
					set = function(info,val)
						self.db.profile[info[1]].Castbar.enabled = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.enabled end
				},
				description = {
					name = "",
					order = 1,
					type = "description"
				},
				direction = {
					name = "Direction",
					desc = "How the Castbar should be animated.",
					order = 2,
					type = "select",
					values = directions,
					set = function(info, val)
						self.db.profile[info[1]].Castbar.direction = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.direction end
				},
				rotation = {
					name = "Rotation",
					desc = "Rotates the castbar's starting point",
					order = 3,
					type = "range",
					min = 0,
					max = 360,
					step = 90,
					set = function(info, val)
						self.db.profile[info[1]].Castbar.rotation = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.rotation end
				},
				size = {
					name = "Size",
					desc = "Size",
					order = 4,
					type = "range",
					min = 20,
					max = 150,
					step = 1,
					set = function(info, val)
						self.db.profile[info[1]].Castbar.size = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.size end
				},
				alpha = {
					name = "Alpha",
					desc = "Castbar alpha",
					order = 4.2,
					type = "range",
					min = 0,
					max = 1,
					step = 0.05,
					set = function(info, val)
						self.db.profile[info[1]].Castbar.alpha = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.alpha end
				},
				texture = {
					name = "Texture",
					desc = "Choose the Castbar texture.",
					order = 6,
					type = "select",
					width = "full",
					values = bartextures,
					set = function(info, val)
						self.db.profile[info[1]].Castbar.texture = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.texture end
				},
				staticcolor = {
					name = "Static Color",
					desc = "Enables / disables static color",
					order = 7,
					type = "toggle",
					set = function(info,val)
						self.db.profile[info[1]].Castbar.staticcolor = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.staticcolor end
				},
				color = {
					name = "Color",
					desc = "Select color",
					order = 7.1,
					type = "color",
					get = function(info)
						local t = self.db.profile[info[1]].Castbar.color
						return t.r, t.g, t.b, t.a
					end,
					set = function(info, r, g, b, a)
						local t = self.db.profile[info[1]].Castbar.color
						t.r, t.g, t.b, t.a = r, g, b, a
						CursorCastbar:CreateFrames()
					end,
				},
				posx = {
					name = "X Offset",
					desc = "spell duration text horizontal position",
					order = 10.1,
					type = "range",
					min = -200,
					max = 200,
					step = 1,
					set = function(info, val) 
						self.db.profile[info[1]].Castbar.point.ofsx = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.point.ofsx end
				},
				posy = {
					name = "Y Offset",
					desc = "spell duration text vertical position",
					order = 10.2,
					type = "range",
					min = -200,
					max = 200,
					step = 1,
					set = function(info, val) 
						self.db.profile[info[1]].Castbar.point.ofsy = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Castbar.point.ofsy end
				},
			},
		}
	end
	
	if ot.Latency then
		t.Latency = {
			name = "Latency",
			order = 2,
			type = "group",
			args = {
				enable = {
					name = "Enable",
					desc = "Enables / disables the castbar",
					order = 0,
					type = "toggle",
					set = function(info,val)
						self.db.profile[info[1]].Latency.enabled = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Latency.enabled end
				},
				subtract = {
					name = "Subtract Latency",
					desc = "Subtracts the network latency (lag) from cast time",
					order = 1,
					type = "toggle",
					set = function(info,val) 
						self.db.profile[info[1]].Latency.subtract = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Latency.subtract end
				},
				alpha = {
					name = "Alpha",
					desc = "castbar alpha",
					order = 2,
					type = "range",
					min = 0,
					max = 1,
					step = 0.05,
					set = function(info, val)
						self.db.profile[info[1]].Latency.alpha = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].Latency.alpha end
				},
				
			},
		}
	end
	
	if ot.DurationText then
		t.DurationText = {
			name = "DurationText",
			order = 3,
			type = "group",
			args = {
				enable = {
					name = "Enable",
					desc = "Enables / disables the spell duration text",
					order = 0,
					type = "toggle",
					set = function(info,val)
						self.db.profile[info[1]].DurationText.enabled = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].DurationText.enabled end
				},
				description = {
					name = "",
					order = 0.1,
					type = "description"
				},
				size = {
					name = "Size",
					desc = "spell duration text size",
					order = 0.2,
					type = "range",
					min = 1,
					max = 40,
					step = 1,
					set = function(info, val)
						self.db.profile[info[1]].DurationText.size = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].DurationText.size end
				},
				alpha = {
					name = "Alpha",
					desc = "spell duration text alpha",
					order = 0.3,
					type = "range",
					min = 0,
					max = 1,
					step = 0.05,
					set = function(info, val)
						self.db.profile[info[1]].DurationText.alpha = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].DurationText.alpha end
				},
				posx = {
					name = "X Offset",
					desc = "spell duration text horizontal position",
					order = 2,
					type = "range",
					min = -200,
					max = 200,
					step = 1,
					set = function(info, val) 
						self.db.profile[info[1]].DurationText.point.ofsx = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].DurationText.point.ofsx end
				},
				posy = {
					name = "Y Offset",
					desc = "spell duration text vertical position",
					order = 2.1,
					type = "range",
					min = -200,
					max = 200,
					step = 1,
					set = function(info, val) 
						self.db.profile[info[1]].DurationText.point.ofsy = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].DurationText.point.ofsy end
				},
			},
		}
	end
	
	if ot.SpellText then
		t.SpellText = {
			name = "SpellText",
			order = 4,
			type = "group",
			args = {
				enable = {
					name = "Enable",
					desc = "Enables / disables the castbar spelltext",
					order = 0,
					type = "toggle",
					set = function(info, val)
						self.db.profile[info[1]].SpellText.enabled = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.enabled end
				},
				description = {
					name = "",
					order = 1,
					type = "description"
				},
				rotanchor = {
					name = "Rotation",
					desc = "Rotates the text's starting point",
					order = 3,
					type = "range",
					min = 0,
					max = 360,
					step = 10,
					set = function(info, val)
						self.db.profile[info[1]].SpellText.rotanchor = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.rotanchor end
				},
				radius = {
					name = "Radius",
					desc = "The radial text offset",
					order = 3.1,
					type = "range",
					min = 1,
					max = 200,
					step = 1,
					set = function(info, val)
						self.db.profile[info[1]].SpellText.radius = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.radius end
				},
				charsize = {
					name = "Char Size",
					desc = "Size of the chars",
					order = 4,
					type = "range",
					min = 10,
					max = 50,
					step = 1,
					set = function(info, val)
						self.db.profile[info[1]].SpellText.charsize = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.charsize end
				},
				charspace = {
					name = "Char Space",
					desc = "Spacing of the chars",
					order = 4.1,
					type = "range",
					min = -20,
					max = -2,
					step = 1,
					set = function(info, val)
						self.db.profile[info[1]].SpellText.charspace = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.charspace end
				},
				color = {
					name = "Color",
					desc = "Select color",
					order = 5,
					type = "color",
					set = function(info, r, g, b, a)
						local t = self.db.profile[info[1]].SpellText.color
						t.r, t.g, t.b, t.a = r, g, b, a
						CursorCastbar:CreateFrames()
					end,
					get = function(info)
						local t = self.db.profile[info[1]].SpellText.color
						return t.r, t.g, t.b, t.a
					end,
				},
				alpha = {
					name = "Alpha",
					desc = "SpellText alpha",
					order = 5.1,
					type = "range",
					min = 0,
					max = 1,
					step = 0.05,
					set = function(info, val)
						self.db.profile[info[1]].SpellText.alpha = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellText.alpha end
				},
			},
		}
	end
	
	if ot.SpellIcon then
		t.SpellIcon = {
			name = "SpellIcon",
			order = 5,
			type = "group",
			args = {
				enable = {
					name = "Enable",
					desc = "Enables / disables the SpellIcon",
					order = 0,
					type = "toggle",
					set = function(info,val)
						self.db.profile[info[1]].SpellIcon.enabled = val
						CursorCastbar:CreateFrames()
					end,
					get = function(info) return self.db.profile[info[1]].SpellIcon.enabled end
				},
				description = {
					name = "",
					order = 1,
					type = "description"
				},
			},
		}
	end

		
	return t
end


local defaults = {
	profile = {
		enabled = true,
		freebutton = {
			alpha = 1,
			scale = 1,
			framelevel = 1,
			framestrata = "MEDIUM",
			roundtexture = true,
			point = {
				p = "CENTER",
				rf = "UIParent",
				rp = "CENTER",
				x = 0,
				y = 0,
			},
			behavior = {
				regclick = "Up",
				autoshowmenuonmouseover = false,
			},
		},
		menu = {
			alpha = 1,
			scale = 1,
			framelevel = 1,
			framestrata = "MEDIUM",
			relativepoint = "LEFT",
			texture = "Own",
			roundtexture = true,
			visualisation = {
				nummodels = 3,
				modelscale = 0.02,
				animationtime = 2,	--in sec
				shape = "round",
			},
			point = {
				p = "RIGHT",
				rf = "Poisoner_FreeButton",
				rp = "LEFT",
				x = 0,
				y = 0,
			},
		},
		aurabutton = {
			alpha = 1,
			lowalpha = 0.5,
			scale = 1,
			framelevel = 1,
			framestrata = "MEDIUM",
			point = {
				p = "CENTER",
				rf = "UIParent",
				rp = "CENTER",
				x = 0,
				y = 0,
			},
		},
		warning = {
			delay = 30,	--in sec
			warnonlyonce = false,
		},
		poisons = {
			lastused = {
				["Lethal"] = "",
				["Non-Lethal"] = "",
			},
			ignored = {},
			
		},
	},
}

function Poisoner:OnInitialize()
		
	self.db = LibStub("AceDB-3.0"):New("PoisonerDB", defaults, true)
	
--	self.options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	LibStub("AceConfigRegistry-3.0"):RegisterOptionsTable("Poisoner", Poisoner:GetOptions())
	LibStub("AceConfig-3.0"):RegisterOptionsTable("PoisonerSlashCommand", Poisoner.OptionsSlash, {"Poisoner", "poisoner"})
	
	Poisoner.debug = false
	
end

function Poisoner:ToggleEnable()
	if Poisoner.enabled then
		Poisoner:OnEnable()
	else
		Poisoner:OnDisable()
	end
end

function Poisoner:OnEnable()
--Check Playerclass
	playerClass = select(2,UnitClass("player"))
	playerGUID = UnitGUID("player")
--Events
	for k,v in pairs(events) do
		self:RegisterEvent(k)
	end
	
	Poisoner.enabled = true
	
--Create Frames
	Poisoner:CreateFrames()
	Poisoner:CheckBuffs()
end

function Poisoner:OnDisable()
	for k,v in pairs(events) do
		self:UnregisterEvent(k)
	end
	Poisoner.enabled = false
end


-- Slash commands
Poisoner.OptionsSlash = {
	type = "group",
	name = "Slash Command",
	order = -3,
	args = {
		config = {
			type = "execute",
			name = "Configure",
			desc = "Open the configuration dialog ( /poisoner config )",
			func = function() Poisoner:ShowConfig() end,
			guiHidden = true,
		},
		enable = {
			type = "execute",
			name = "Enable",
			desc = "Enable Poisoner ( /poisoner show )",
			func = function() Poisoner:OnEnable() end,
		},
		disable = {
			type = "execute",
			name = "Disable",
			desc = "Disable Poisoner ( /poisoner hide )",
			func = function() Poisoner:OnDisable() end,
		},
	},
}

-- Config
function Poisoner:ShowConfig()
	-- not using Blizzard's Interface options because of taint issues
--	InterfaceOptionsFrame_OpenToCategory("Poisoner")
	if Poisoner.InCombatLockdown or InCombatLockdown() then
		--Poisoner.NeedUpdate = true
		return
	end
	LibStub("AceConfigDialog-3.0"):Open("Poisoner")
end

-- Options table
function Poisoner:GetOptions()
if not Poisoner.Options then
	Poisoner.Options = {
		type = "group",
		name = "Poisoner",
		handler = Poisoner,
		set = function(info, value) db[ info[#info] ] = value end,
		get = function(info) return db[ info[#info] ] end,
		args = {
			enable = {
				name = "Enable",
				desc = "Enables / disables Poisoner",
				order = 0,
				type = "toggle",
				set = function(info,val)
						Poisoner.enabled = val
						self.db.profile.enabled = val
						Poisoner:ToggleEnable()
					end,
				get = function(info) return self.db.profile.enabled end
			},
			menu = {
				name = "Classic Menu",
				order = 1,
				type = "group",
				args = {
					scale = {
						name = "Scale",
						desc = "Poisoner main frame scale",
						order = 1,
						type = "range",
						min = 0.2,
						max = 2,
						step = 0.1,
						set = function(info, val) self.db.profile.menu.scale = val end,
						get = function(info) return self.db.profile.menu.scale end
					},
					alpha = {
						name = "Alpha",
						desc = "Poisoner main frame alpha",
						order = 2,
						type = "range",
						min = 0,
						max = 1,
						step = 0.05,
						set = function(info, val) self.db.profile.menu.alpha = val end,
						get = function(info) return self.db.profile.menu.alpha end
					},
					--[[
					anchor = {
						name = "Anchor",
						desc = "The frame/point Poisoner is anchored to",
						order = 3,
						type = "select",
						values = anchors,
						set = function(info, val) self.db.profile.menu.anchor = val end,
						get = function(info) return self.db.profile.menu.anchor end
					},
					]]
				},
			},
			warning = {
				name = "Warnings",
				order = 3,
				type = "group",
				args = {
					delay = {
						name = "Update delay (ms)",
						desc = "OptiTaunt update delay in milliseconds.\n|cffff6d00Increasing|r the value results in less CPU/second usage but coarses the animation.\n|cffff6d00Decreasing|r the value results in more CPU/second usage but smoothes the animation.",
						order = 0,
						type = "range",
						min = 10,
						max = 500,
						step = 10,
						width = "full",
						set = function(info, val) self.db.profile.warning.delay = val end,
						get = function(info) return self.db.profile.warning.delay end
					},
				},
			},
			
			profile = {
				name = "Profile",
				order = -1,
				type = "group",
				args = {
				},
			},
		}
	}
	
end

	Poisoner.Options.args.profile = LibStub("AceDBOptions-3.0"):GetOptionsTable(self.db)
	
	return Poisoner.Options
end


function Poisoner:PLAYER_LOGIN()
	playerGUID = UnitGUID("player")
	Poisoner:CreateFrames()
end

function Poisoner:PLAYER_ENTERING_WORLD()
	Poisoner:CheckBuffs()
end

function Poisoner:UNIT_AURA(UnitId)
	if UnitId ~= "player" then return end
	Poisoner:CheckBuffs()
	Poisoner:UnregisterEvent("UNIT_AURA")	--Only call this once on login. Poisoner uses CLEU for buff tracking afterwards for more CPU efficiency (filtering)
end

function Poisoner:PLAYER_REGEN_ENABLED()
	Poisoner.InCombatLockdown = false
	if Poisoner.NeedUpdate then
		Poisoner:CreateButtons()
		Poisoner:CheckBuffs()
	end
end
function Poisoner:PLAYER_REGEN_DISABLED()
	Poisoner.InCombatLockdown = true
end

function Poisoner:SPELLS_CHANGED()
	Poisoner:CreateButtons()
	Poisoner:CheckBuffs()
end

function Poisoner:COMBAT_LOG_EVENT_UNFILTERED(eventfuncname, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, auraType, amount)
--	print(eventfuncname, timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, sourceRaidFlags, destGUID, destName, destFlags, destRaidFlags, spellId, spellName, spellSchool, auraType, amount)
	debug("Poisoner CLEU")
	if destGUID ~= playerGUID then debug("1") return end
	if not spells[spellId] then debug("2") return end
	if not CLEU_events[event] then debug("3") return end
	
	if event == "SPELL_AURA_APPLIED" then
		currentbuffs[spellId] = Poisoner:GetBuffDuration(spellId, spellName)
		self.db.profile.poisons.lastused[spellgroup[spellId]] = spellId
	elseif event == "SPELL_AURA_REMOVED" then
		if currentbuffs[spellId] then
			currentbuffs[spellId] = nil
		end
	end
	
end


function Poisoner:GetSpellTexture(spellId)
	local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(spellId)
	return icon
end

function Poisoner:GetAllSpellTextures()
	for k,v in pairs(spells) do
		print(Poisoner:GetSpellTexture(k))
	end
end

function Poisoner:CreateFrames()
	Poisoner:CreateMainButton()
	Poisoner:CreateMenu()
	Poisoner:CreateButtons()
end



-- local frame functions
local function modkeys()
	local shift, ctrl, alt = IsShiftKeyDown(), IsControlKeyDown(), IsAltKeyDown()
	local modkey = ""
			
	if shift then modkey = modkey.."shift" end
	if ctrl then modkey = modkey.."ctrl" end
	if alt then modkey = modkey.."alt" end
	--print("ReqKey", reqmod,"- ModKey:", modkey)
	
	return modkey
end

local function savepos(frame, optstring)
	local p, f, rp, x, y = frame:GetPoint()
	if f then
		f = f:GetName()
	elseif f == nil then
		f = "UIParent"
	end
	local t = {p, f or "UIParent", rp, x, y}
	Poisoner.db.profile[optstring].point = {
		p = p, rf = f, rp = rp, x = x, y = y,
	}
end

local function tooltipShow(owner, direction, typ, value)
	--print(owner:GetName(), direction, typ, value, type(value))
	if typ == "text" then
		GameTooltip:SetOwner(owner, direction or "BOTTOMLEFT")
		GameTooltip:SetText(value)
	elseif typ == "spellid" or typ == "itemid" then
		GameTooltip:SetOwner(owner, direction or "BOTTOMLEFT")
		GameTooltip:SetHyperlink(GetSpellLink(value))
	end
	GameTooltip:Show()
end
local function tooltipHide()
	GameTooltip:ClearLines()
	GameTooltip:Hide()
end


-- Classic Menu

function Poisoner:CreateMainButton()
	local pfb = _G["Poisoner_FreeButton"]
	if pfb == nil then
		pfb = CreateFrame("BUTTON", "Poisoner_FreeButton", UIParent, "SecureHandlerClickTemplate, SecureHandlerBaseTemplate, SecureHandlerEnterLeaveTemplate, SecureHandlerMouseWheelTemplate");
	end
	pfb:RegisterForDrag("LeftButton");
	pfb:SetMovable();
	local modkey = "shift"
	pfb:SetScript("OnDragStart", function(self)
		if modkeys() == modkey then
			self:StartMoving()
			self.IsMoving = true
		end
	end);
	pfb:SetScript("OnDragStop", function(self)
		if self.IsMoving == true then
			self:StopMovingOrSizing()
			self.IsMoving = false
			savepos(self, "freebutton")
		end
	end);
	print("Poisoner:CreateButtons()", self.db.freebutton)
	pfb:RegisterForClicks("Any"..(self.db.profile.freebutton.behavior.regclick or "Up"));
--	pfb:SetClampedToScreen(true);
	pfb:SetSize(32,32)
	pfb:ClearAllPoints();
	local t = self.db.profile.freebutton.point
	pfb:SetPoint(t.p, t.rf, t.rp, t.x, t.y);
	
	local texture = textureprefix.."ability_creature_poison_06"..texturesuffix
	
	pfb.Texture = pfb:CreateTexture(pfb:GetName().."Icon", "ARTWORK");
	pfb.Texture:SetTexture(texture);
	pfb.Texture:SetAllPoints(pfb);
	
	pfb:SetNormalTexture(texture);
	pfb:SetHighlightTexture(texture);
	
	if self.db.profile.freebutton.roundtexture then
		SetPortraitToTexture(pfb:GetNormalTexture(), texture)
		SetPortraitToTexture(pfb:GetHighlightTexture(), texture)
		SetPortraitToTexture(_G[pfb:GetName().."Icon"], texture)
	end
	
	pfb:SetAttribute("modkey", "shift")
	
	local function onenter()
		tooltipShow(Poisoner_FreeButton, "BOTTOMRIGHT", "text", "CLICK  |cffffffffto toggle the menu|r \nSHIFT and DRAG  |cffffffffto move the button around (even in combat)|r \nSHIFT and MOUSEWHEEL  |cffffffffto scale the button from 0.1 to 2.0 (even in combat)|r ")
	end
	
	pfb.OnEnter = onenter
	pfb.OnLeave = tooltipHide
	
	pfb:SetAttribute("_onclick", [=[
		local left, right, middle, menu = button == "LeftButton", button == "RightButton", button == "MiddleButton", self:GetFrameRef("menu");
		
		if right then
			--[[
			if options:IsVisible() then
					options:Hide();
			elseif options:IsShown() then
				options:Hide();
			else
				options:Show();
			end
			]]
		elseif left then
			if menu:IsVisible() then
				menu:Hide();
			elseif menu:IsShown() then
				menu:Hide();
			else
				menu:Show();
			end
		elseif middle then
			print("QuickButton updated.")
		end
		
		
	]=]);
	
	pfb:SetAttribute("_onmousewheel", [=[
		local up, down, menu = delta == 1, delta == -1, self:GetFrameRef("menu");
		local reqmod, modkey = self:GetAttribute("modkey"), ""
		local shift, ctrl, alt = IsShiftKeyDown(), IsControlKeyDown(), IsAltKeyDown()
		
		if shift then modkey = modkey.."shift" end
		if ctrl then modkey = modkey.."ctrl" end
		if alt then modkey = modkey.."alt" end
		--print("ReqKey", reqmod,"- ModKey:", modkey)
		
		if modkey ~= reqmod then return end
		
		local sScale = self:GetScale()
		local mScale = menu:GetScale()
		local ofsScale = 0.1
		
		if up and (sScale <= 2 or mScale <= 2) then
			self:SetScale(sScale + ofsScale)
			menu:SetScale(mScale + ofsScale)
		elseif down and (sScale >= 0.1 or mScale >= 0.1) then
			self:SetScale(sScale - ofsScale)
			menu:SetScale(mScale - ofsScale)
		end
		
	]=])
	
	
	pfb:SetAttribute("_onenter", [=[
		--[[
		local menu, psf = self:GetFrameRef("frame1"), self:GetFrameRef("PoisonSlotFrame");
		
		local som = psf:GetAttribute("showmouseover")
		
		if som then
			if menu:IsVisible() then
				menu:Hide();
			elseif menu:IsShown() then
				menu:Hide();
			else
				menu:Show();
			end
		end
		]]
		control:CallMethod("OnEnter", self)
	]=])
	pfb:SetAttribute("_onleave", [=[
		--[[
		local menu, psf = self:GetFrameRef("frame1"), self:GetFrameRef("PoisonSlotFrame");
		local som = psf:GetAttribute("showmouseover")
		
		if som then
			menu:Hide();
		end
		]]
		control:CallMethod("OnLeave")
	]=])
	
	if true then return pfb end
	pfb:SetAttribute("_onclick", [=[
		local left, right, middle, menu, options, qb, psf = button == "LeftButton", button == "RightButton", button == "MiddleButton", self:GetFrameRef("frame1"), self:GetFrameRef("frame2"), self:GetFrameRef("button1"), self:GetFrameRef("PoisonSlotFrame");
		local overwrite = psf:GetAttribute("overwrite")
		
		if right then
			--[[
			if options:IsVisible() then
					options:Hide();
			elseif options:IsShown() then
				options:Hide();
			else
				options:Show();
			end
			]]
		elseif left then
			if menu:IsVisible() then
				menu:Hide();
			elseif menu:IsShown() then
				menu:Hide();
			else
				menu:Show();
			end
		elseif middle then
			--print("QuickButton updated.")
		end
		
		local poison1, poison2, poison3, poison4, poison5, poison6, poison7, poison8, poison9, poison10, poison11, poison12
		poison1 = psf:GetAttribute("Text1")
		poison2 = psf:GetAttribute("Text2")
		poison3 = psf:GetAttribute("Text3")
		poison4 = psf:GetAttribute("Text4")
		poison5 = psf:GetAttribute("Text5")
		poison6 = psf:GetAttribute("Text6")
		poison7 = psf:GetAttribute("Text7")
		poison8 = psf:GetAttribute("Text8")
		poison9 = psf:GetAttribute("Text9")
		poison10 = psf:GetAttribute("Text10")
		poison11 = psf:GetAttribute("Text11")
		poison12 = psf:GetAttribute("Text12")
		
		--print("Poisons:\n"..poison1.."\n"..poison2.."\n"..poison3.."\n"..poison4.."\n"..poison5.."\n"..poison6.."\n"..poison7.."\n"..poison8.."\n"..poison9.."\n"..poison10.."\n"..poison11.."\n"..poison12)
		
		--Poisoner_QuickButton_Text = "/use [nomodifier,button:3] "..poison9.."\n/use [modifier:shift,button:3] "..poison10.."\n/use [modifier:ctrl,button:3] "..poison11.."\n/use [modifier:alt,button:3] "..poison12.."\n/use [button:3] 18\n/use [nomodifier,button:2] "..poison5.."\n/use [modifier:shift,button:2] "..poison6.."\n/use [modifier:ctrl,button:2] "..poison7.."\n/use [modifier:alt,button:2] "..poison8.."\n/use [button:2] 17\n/use [nomodifier,button:1] "..poison1.."\n/use [modifier:shift,button:1] "..poison2.."\n/use [modifier:ctrl,button:1] "..poison3.."\n/use [modifier:alt,button:1] "..poison4.."\n/use [button:1] 16\n/click StaticPopup1Button1\n/run PoisonerOptions_CheckPoisons()"
		--print(Poisoner_QuickButton_Text)	
		--qb:SetAttribute("type", "macro");
		--qb:SetAttribute("macrotext", "TEST");
		if overwrite then
			qb:SetAttribute("macrotext", "/use [nomodifier,button:3] "..poison9.."\n/use [modifier:shift,button:3] "..poison10.."\n/use [modifier:ctrl,button:3] "..poison11.."\n/use [modifier:alt,button:3] "..poison12.."\n/use [button:3] 18\n/use [nomodifier,button:2] "..poison5.."\n/use [modifier:shift,button:2] "..poison6.."\n/use [modifier:ctrl,button:2] "..poison7.."\n/use [modifier:alt,button:2] "..poison8.."\n/use [button:2] 17\n/use [nomodifier,button:1] "..poison1.."\n/use [modifier:shift,button:1] "..poison2.."\n/use [modifier:ctrl,button:1] "..poison3.."\n/use [modifier:alt,button:1] "..poison4.."\n/use [button:1] 16\n/click StaticPopup1Button1\n/run PoisonerOptions_CheckPoisons()");
		end
		
	]=]);

	
	return pfb
	
end

function Poisoner:CreateMenu()
	local pfb = _G["Poisoner_FreeButton"] or Poisoner:CreateMainButton()
	local pmenu = _G["Poisoner_Menu"]
	if pmenu == nil then
		pmenu = CreateFrame("Frame", "Poisoner_Menu", UIParent, "SecureHandlerEnterLeaveTemplate");
	end
	pmenu:SetSize(64*4,64)
	pmenu:ClearAllPoints();
	pmenu:SetPoint("RIGHT",Poisoner_FreeButton,"LEFT");
	--[[
	local texture = textureprefix.."ability_creature_poison_06"..texturesuffix
	pmenu.Texture = pmenu:CreateTexture(pmenu:GetName().."Icon", "ARTWORK");
	pmenu.Texture:SetTexture(texture);
	pmenu.Texture:SetAllPoints();
	]]
	_G["Poisoner_FreeButton"]:SetFrameRef("menu", Poisoner_Menu);
	
	return pmenu
end

function Poisoner:CreateButtons()
	if Poisoner.InCombatLockdown or InCombatLockdown() then Poisoner.NeedUpdate = true return end
	
	local pmenu = Poisoner:CreateMenu()
	local pmenuwidth = 0
	local prevbutton
	for cat,spells in pairs(poisons) do
		prevbutton = nil
		for spellID,v in pairs(spells) do
			local buttonName = "Poisoner_MenuButton__"..spellID;
			local button = _G[buttonName];
			if IsSpellKnown(spellID) then
				
				if button == nil then
					
					button = CreateFrame("Button", buttonName, pmenu, "SecureActionButtonTemplate, SecureHandlerEnterLeaveTemplate, SecureHandlerAttributeTemplate,SecureHandlerDragTemplate,SecureHandlerMouseUpDownTemplate")
					button:SetHeight(32)
					button:SetWidth(32)
					--button:ClearAllPoints();
					--button:SetPoint("CENTER",UIParent,"CENTER");
					
					button.Name = GetSpellInfo(spellID)
					button.spellID = spellID
					
					local name, rank, icon = GetSpellInfo(spellID)
										
					button:RegisterForClicks("AnyDown");
					
					button:SetAttribute("name", name);
					button:SetAttribute("spellID", spellID);
					button:SetAttribute("cat", cat);
					button:SetAttribute("type", "macro");
					button:SetAttribute("macrotext", "/cast "..name)
					
					local texture = gsub(icon, "Interface\\Icons\\", "Interface\\AddOns\\Poisoner\\images\\")
					
					button:SetNormalTexture(texture);
					button:SetHighlightTexture(texture);
					
					button.Texture = button:CreateTexture(button:GetName().."Icon", "ARTWORK");
					button.Texture:SetTexture(texture);
					button.Texture:SetAllPoints(button);
					
					if true then
						SetPortraitToTexture(button:GetNormalTexture(), texture)
						SetPortraitToTexture(button:GetHighlightTexture(), texture)
						SetPortraitToTexture(_G[button:GetName().."Icon"], texture)
					end
					
					local bfs = button:CreateFontString(buttonName.."Text","OVERLAY","GameFontNormal");
					bfs:SetPoint("BOTTOMRIGHT");
					bfs:SetTextColor(1,1,1,1);
					bfs:SetShadowColor(0,0,0,1);
					bfs:SetShadowOffset(-2,2);
					button:SetFontString(bfs);
					
					
					SecureHandlerWrapScript(button, "PostClick", button, [=[
						local left, right, middle, cat, spellName, pfb = button == "LeftButton", button == "RightButton", button == "MiddleButton", self:GetAttribute("cat"), self:GetAttribute("name"), self:GetFrameRef("pfb");
						
					--	print(self:GetName(), cat, spellName)
						
						pfb:SetAttribute(cat, spellName)
						
						if true then return end
						
						if right then
							
						elseif left then
							
						elseif middle then
							
						end
						
						
					]=]);
					
					button:SetScript("OnEnter", function(self) tooltipShow(self, nil, "spellid", self.spellID) end)
					button:SetScript("OnLeave", function() tooltipHide() end)
					
					button:SetFrameRef("pfb", Poisoner_FreeButton)
					
				end
				
				-- >>> Visuals
					local nummodels = self.db.profile.menu.visualisation.nummodels or 3
					if nummodels > maxtempmodels then maxtempmodels = nummodels end
					if true then
						for i=1,nummodels do
							local Model = _G[buttonName.."Model"..i]
							if not Model then
								Model = CreateFrame("Model", buttonName.."Model"..i, button);
							end
							Model:SetAllPoints( nil ); -- Fullscreen
							Model:Show();
							Model:SetLight( 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1 );
							Model:SetModel("spells\\lightning_fel_precast_low_hand.mdx")
							Model:SetModelScale(0.02)
							Model:SetFacing(0)
							Model:SetFrameStrata(button:GetFrameStrata())
						end
						for i=nummodels+1,maxtempmodels do
							local Model = _G[buttonName.."Model"..i]
							if Model then
								Model:SetModelScale(0.0)
								Model:Hide()
							end
						end
						
						local UIScale = UIParent:GetEffectiveScale()
						local Hypotenuse = ( GetScreenWidth() ^ 2 + GetScreenHeight() ^ 2 ) ^ 0.5 * UIScale
						local roundtime, starttime = self.db.profile.menu.visualisation.animationtime*1000 or 2000, GetTime()*1000
						local endtime = starttime + roundtime
						local scale = self.db.profile.menu.visualisation.modelscale
						local shape = self.db.profile.menu.visualisation.shape
						
						button:SetScript("OnUpdate", function(self)
							local X,Y
							X = ( (button:GetRight() or 0) + (button:GetLeft() or 0) ) /2
							Y = ( (button:GetTop() or 0) + (button:GetBottom() or 0) ) /2
							local currenttime = GetTime()*1000
							for i=1,nummodels do
								local Model = _G[buttonName.."Model"..i]
								if endtime >= currenttime then
									local ofsa = (360 / nummodels) * i
									local per = (endtime - currenttime) / ((endtime - starttime) / 100)
									local angle = 360/100*per + ofsa
									local ofsx, ofsy
									if shape == "square" then
										ofsx, ofsy = GetSquarePoint(angle, self:GetSize())
									else
										ofsx, ofsy = GetCircularPoint(angle, 16)
									end
									Model:SetPosition( ( X + ofsx) / Hypotenuse, ( Y + ofsy) / Hypotenuse, 0 );
								else
									starttime = currenttime
									endtime = currenttime + roundtime
								end
								if currentbuffs[button.spellID] then
									Model:SetModelScale(scale or 0.02)
								else
									Model:SetModelScale(0.0)
								end
							end
						end)
						
					end
				-- <<< Visuals
				
				button:ClearAllPoints();
				if prevbutton then
					button:SetPoint("RIGHT", prevbutton, "LEFT");
				else
					if cat == "Lethal" then
						button:SetPoint("TOPRIGHT", pmenu, "TOPRIGHT");
					else
						button:SetPoint("BOTTOMRIGHT", pmenu, "BOTTOMRIGHT");
					end
				end
				button:Show()
				prevbutton = button
				
				pmenuwidth = pmenuwidth + button:GetWidth()
				
			else
				if button then
					button:Hide()
					button:SetScript("OnUpdate", nil)
				end
			end
		end		
	end
	
	pmenu:SetWidth(pmenuwidth)
	
end


-- AuraButtons
function Poisoner:CreateAuraButtonFrame()
	local abf = _G["Poisoner_AuraButtonFrame"]
	if abf == nil then
		abf = CreateFrame("Frame", "Poisoner_AuraButtonFrame", UIParent, "SecureHandlerClickTemplate, SecureHandlerBaseTemplate, SecureHandlerEnterLeaveTemplate");
		abf:SetSize(64*2,64)
		abf:ClearAllPoints();
		abf:SetPoint("CENTER", UIParent, "CENTER", 0, 0);
		abf:Show()
		--[[
		local texture = textureprefix.."ability_creature_poison_06"..texturesuffix
		abf.Texture = abf:CreateTexture(abf:GetName().."Icon", "ARTWORK");
		abf.Texture:SetTexture(texture);
		abf.Texture:SetAllPoints();
		]]
	end
	return abf
end

function Poisoner:CreateAuraButtons()
	local abf = _G["Poisoner_AuraButtonFrame"] or Poisoner:CreateAuraButtonFrame()
	
	for cat,spells in pairs(poisons) do
		local buttonName = "Poisoner_AuraButton__"..cat;
		local button = _G[buttonName];
		if button == nil then
			button = CreateFrame("Button", buttonName, UIParent, "SecureActionButtonTemplate, SecureHandlerEnterLeaveTemplate, SecureHandlerAttributeTemplate,SecureHandlerDragTemplate,SecureHandlerMouseUpDownTemplate")
		end
		button:SetHeight(32)
		button:SetWidth(32)
		button:SetFrameStrata(abf:GetFrameStrata())
		button:SetFrameLevel(abf:GetFrameLevel()+1)
		button:ClearAllPoints();
		
		button:RegisterForClicks("AnyDown");
				
		button.Name = cat
		button:SetAttribute("cat", cat);
		
		local macrostring = ""
		if cat == "Lethal" then
			
			button:SetPoint("LEFT", abf, "LEFT", 0, 0);
			
			local i = 1
			for spellID,v in pairs(spells) do
			
				local texture = button:CreateTexture(button:GetName().."Icon"..i, "ARTWORK");
				
				local name, rank, icon = GetSpellInfo(spellID)
				
				local texturestring = gsub(icon, "Interface\\Icons\\", "Interface\\AddOns\\Poisoner\\images\\")
				
				texture:SetTexture(texturestring)
				
				texture:SetSize(button:GetWidth()/2, button:GetHeight())
				
				if i == 1 then
					texture:SetTexCoord(get8coords(0,0.5,0,1,0))
					texture:SetPoint("LEFT", button, "LEFT", 0, 0)
					macrostring = macrostring.."/cast [button:"..i.."]"..name
					button:SetAttribute("button:"..i, name)
				else
					texture:SetTexCoord(get8coords(0.5,1,0,1,0))
					texture:SetPoint("RIGHT", button, "RIGHT", 0, 0)
					macrostring = macrostring.."\n/cast [button:"..i.."] "..name
					button:SetAttribute("button:"..i, name)
				end
				
				i = i + 1
			end
			
			button.ChangeTextures = function(self)
				local tex1, tex2 = _G[self:GetName().."Icon1"], _G[self:GetName().."Icon2"]
				local oldtex1, oldtex2 = tex1:GetTexture(), tex2:GetTexture()
				
				tex1:SetTexture(oldtex2)
				tex1:SetTexCoord(get8coords(0,0.5,0,1,0))
				tex1:SetPoint("LEFT", button, "LEFT", 0, 0)
			
				tex2:SetTexture(oldtex1)
				tex2:SetTexCoord(get8coords(0.5,1,0,1,0))
				tex2:SetPoint("RIGHT", button, "RIGHT", 0, 0)
				
			end
			
			SecureHandlerWrapScript(button, "PostClick", button, [=[
				local left, right, middle, cat, spellName, pfb = button == "LeftButton", button == "RightButton", button == "MiddleButton", self:GetAttribute("cat"), self:GetAttribute("name"), self:GetFrameRef("pfb");
				
			--	print(self:GetName(), cat, spellName)
				
			--	pfb:SetAttribute(cat, spellName)
				
				if right then
					local old1, old2 = self:GetAttribute("button:1"), self:GetAttribute("button:2")
					self:SetAttribute("button:1", old2)
					self:SetAttribute("button:2", old1)
					self:SetAttribute("macrotext", "/cast [button:1] "..self:GetAttribute("button:1").."; [button:2]"..self:GetAttribute("button:2"))
					self:CallMethod("ChangeTextures")
				end
				
				
			]=]);
			
			button:SetScript("OnEnter", function(self)
			--	tooltipShow(self, nil, "spellid", self.spellID)
				for i = 1,2 do
					_G[button:GetName().."Icon"..i]:SetBlendMode("ADD")
				end
			end)
			button:SetScript("OnLeave", function()
				tooltipHide()
				for i = 1,2 do
					_G[button:GetName().."Icon"..i]:SetBlendMode("DISABLE")
				end
			end)
			
		else
			
			button:SetPoint("RIGHT", abf, "RIGHT", 0, 0);
			
			local mods = {[1] = "nomod", [2] = "shift", [3] = "ctrl", [4] = "alt"}
			
			for i,m in ipairs(mods) do
				local texture = button:CreateTexture(button:GetName().."Icon"..i, "ARTWORK")
				
				texture:ClearAllPoints()
				
				if v == 1 then
					texture:SetPoint("TOPLEFT", button, "TOPLEFT", 0, 0)
				elseif v == 2 then
					texture:SetPoint("TOPRIGHT", button, "TOPRIGHT", 0, 0)
				elseif v == 3 then
					texture:SetPoint("TOPLEFT", button, "BOTTOMLEFT", 0, 0)
				elseif v == 4 then
					texture:SetPoint("BOTTOMRIGHT", button, "BOTTOMRIGHT", 0, 0)
				end
				
			end
			
			
			
		end
		
		
		button:SetAttribute("type", "macro")
		button:SetAttribute("macrotext", macrostring)
		
	end
	
end


--[[
	TIMER
]]
-- lookup the duration of the spells

function Poisoner:CheckBuffs()
	currentbuffs = {}
	local currentTime = GetTime()*1000
	for k,v in pairs(spells) do
		local spellName = GetSpellInfo(k)
		local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3
		if spellName then
			name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", spellName)
		end
		if name then
			currentbuffs[k] = expirationTime*1000
			self.db.profile.poisons.lastused[spellgroup[spellId]] = spellId
		end
	end
	
	return currentbuffs
end

function Poisoner:GetAllBuffDurations()
	if currentbuffs == {} then
		currentbuffs = Poisoner:CheckBuffs()
	end
	
	return currentbuffs
end

function Poisoner:GetBuffDuration(reqspellId, spellName)
	if not tonumber(reqspellId) then return nil end
	local currentTime = GetTime()*1000
	local bufftime	
	local spellName = spellName or GetSpellInfo(reqspellId)
	local name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3
	if spellName then
		name, rank, icon, count, debuffType, duration, expirationTime, unitCaster, isStealable, shouldConsolidate, spellId, canApplyAura, isBossDebuff, value1, value2, value3 = UnitBuff("player", spellName)
	end
	if name and spellId == reqspellId then
		bufftime = expirationTime*1000
	end
		
	return bufftime
end


function Poisoner:Test()
	print("Poisoner TEST")
	print("Poisoner playerGUID = ", playerGUID)
end

